=== modified file 'Makefile'
--- Makefile	2011-03-14 08:47:03 +0000
+++ Makefile	2007-10-29 16:19:30 +0000
@@ -8,4 +8,5 @@
 	rm -rf dist/
 
 check:
-	BZR_PLUGINS_AT=loggerhead@$$(pwd) bzr selftest -s bp.loggerhead
+	# XXX MichaelHudson 2007-10-29 bug=158361: We can't run the loggerhead
+	# tests in PQM yet :(

=== modified file 'NEWS'
--- NEWS	2011-03-25 11:38:43 +0000
+++ NEWS	2011-03-04 15:49:43 +0000
@@ -9,12 +9,6 @@
       multiple threads, and issue concurrent requests.
       (John Arbash Meinel)
 
-    - HEAD requests should not return body content. This is done by adding
-      another wsgi middleware that strips the body when the REQUEST_METHOD is
-      HEAD. Note that you have to add the middleware into your pipeline, and
-      it does not decrease the actual work done.
-      (John Arbash Meinel, #716201)
-
     - If we get a HEAD request, there is no reason to expand the template, we
       shouldn't be returning body content anyway.
       (John Arbash Meinel, #716201, #716217)
@@ -22,29 +16,12 @@
     - Merge the pqm changes back into trunk, after trunk was reverted to an old
       revision. (John Arbash Meinel, #716152)
 
-    - Redirect ``/files/file.txt`` to ``/view/file.txt`` and ``/view/dir`` to
-      ``/files/dir``. (Jasper St. Pierre, #569358)
+    - The json module is no longer claimed to be supported as alternative for 
+      simplejson. (Jelmer Vernooij, #586611)
 
     - Remove ``start-loggerhead`` and ``stop-loggerhead`` which were already
       deprecated. (John Arbash Meinel)
 
-    - Show "Author(s)" as separate from "Committer". And label them
-      correctly. (John Arbash Meinel, #733015)
-
-    - The json module is no longer claimed to be supported as alternative for 
-      simplejson. (Jelmer Vernooij, #586611)
-
-    - Viewing the ``/changes`` page only iterates enough of the history to show
-      the actual revisions displayed, rather than walking the whole mainline.
-      Improves performance on projects with long histories like emacs.
-      (John Arbash Meinel)
-
-    - Fix escaping of filenames in revision views.
-      (William Grant, #740142)
-
-    - Fix support for displaying foreign revision ids.
-      (Jelmer Vernooij, #736026)
-
 
 1.18 [10Nov2010]
 ----------------

=== modified file '__init__.py'
--- __init__.py	2011-03-19 08:35:57 +0000
+++ __init__.py	2011-02-10 01:57:32 +0000
@@ -30,8 +30,6 @@
 starts a web server to browse the contents of a branch.
 """
 
-import sys
-
 from info import (
     bzr_plugin_version as version_info,
     bzr_compatible_versions,
@@ -51,6 +49,17 @@
     HELP = ('Loggerhead, a web-based code viewer and server. (default port: %d)' %
             (DEFAULT_PORT,))
 
+    def setup_logging(config):
+        import logging
+        import sys
+
+        logger = logging.getLogger('loggerhead')
+        handler = logging.StreamHandler(sys.stderr)
+        handler.setLevel(logging.DEBUG)
+        logger.addHandler(handler)
+        logging.getLogger('simpleTAL').addHandler(handler)
+        logging.getLogger('simpleTALES').addHandler(handler)
+
     def _ensure_loggerhead_path():
         """Ensure that you can 'import loggerhead' and get the root."""
         # loggerhead internal code will try to 'import loggerhead', so
@@ -62,19 +71,13 @@
             sys.path.append(os.path.dirname(__file__))
 
     def serve_http(transport, host=None, port=None, inet=None):
-        # TODO: if we supported inet to pass requests in and respond to them,
-        #       then it would be easier to test the full stack, but it probably
-        #       means routing around paste.httpserver.serve which probably
-        #       isn't testing the full stack
         from paste.httpexceptions import HTTPExceptionHandler
         from paste.httpserver import serve
 
         _ensure_loggerhead_path()
 
-        from loggerhead.apps.http_head import HeadMiddleware
         from loggerhead.apps.transport import BranchesFromTransportRoot
         from loggerhead.config import LoggerheadConfig
-        from loggerhead.main import setup_logging
 
         if host is None:
             host = DEFAULT_HOST
@@ -84,9 +87,8 @@
         if not transport.is_readonly():
             argv.insert(0, '--allow-writes')
         config = LoggerheadConfig(argv)
-        setup_logging(config, init_logging=False, log_file=sys.stderr)
+        setup_logging(config)
         app = BranchesFromTransportRoot(transport.base, config)
-        app = HeadMiddleware(app)
         app = HTTPExceptionHandler(app)
         serve(app, host=host, port=port)
 

=== removed file 'loggerhead/apps/http_head.py'
--- loggerhead/apps/http_head.py	2011-02-10 02:33:15 +0000
+++ loggerhead/apps/http_head.py	1970-01-01 00:00:00 +0000
@@ -1,62 +0,0 @@
-# Copyright (C) 2011 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-"""WSGI apps tend to return body content as part of a HEAD request.
-
-We should definitely not do that.
-"""
-
-class HeadMiddleware(object):
-    """When we get a HEAD request, we should not return body content.
-
-    WSGI defaults to just generating everything, and not paying attention to
-    whether it is a GET or a HEAD request. It does that because of potential
-    issues getting the Headers correct.
-
-    This middleware works by just omitting the body if the request method is
-    HEAD.
-    """
-
-    def __init__(self, app):
-        self._wrapped_app = app
-        self._real_environ = None
-        self._real_start_response = None
-        self._real_writer = None
-
-    def noop_write(self, chunk):
-        """We intentionally ignore all body content that is returned."""
-        pass
-
-    def start_response(self, status, response_headers, exc_info=None):
-        if exc_info is None:
-            self._real_writer = self._real_start_response(status,
-                response_headers)
-        else:
-            self._real_writer = self._real_start_response(status,
-                response_headers, exc_info)
-        return self.noop_write
-
-    def __call__(self, environ, start_response):
-        self._real_environ = environ
-        self._real_start_response = start_response
-        if environ.get('REQUEST_METHOD', 'GET') == 'HEAD':
-            result = self._wrapped_app(environ, self.start_response)
-            for chunk in result:
-                pass
-        else:
-            result = self._wrapped_app(environ, start_response)
-            for chunk in result:
-                yield chunk

=== modified file 'loggerhead/apps/transport.py'
--- loggerhead/apps/transport.py	2011-03-16 14:43:36 +0000
+++ loggerhead/apps/transport.py	2010-05-05 18:35:35 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008-2011 Canonical Ltd.
+# Copyright (C) 2008, 2009 Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'loggerhead/config.py'
--- loggerhead/config.py	2010-05-12 14:38:05 +0000
+++ loggerhead/config.py	2010-04-13 23:35:01 +0000
@@ -49,12 +49,6 @@
     parser.add_option("--protocol", dest="protocol",
                       help=("Protocol to use: http, scgi, fcgi, ajp"
                            "(defaults to http)."))
-    parser.add_option("--log-level", default=None, action='callback',
-                      callback=_optparse_level_to_int_level,
-                      type="string",
-                      help="Set the verbosity of logging. Can either"
-                           " be set to a numeric or string"
-                           " (eg, 10=debug, 30=warning)")
     parser.add_option("--memory-profile", action="store_true",
                       help="Profile the memory usage using Dozer.")
     parser.add_option("--prefix", dest="user_prefix",
@@ -78,29 +72,6 @@
     return parser
 
 
-_log_levels = {
-    'debug': 10,
-    'info': 20,
-    'warning': 30,
-    'error': 40,
-    'critical': 50,
-}
-
-def _optparse_level_to_int_level(option, opt_str, value, parser):
-    parser.values.log_level = _level_to_int_level(value)
-
-
-def _level_to_int_level(value):
-    """Convert a string level to an integer value."""
-    if value is None:
-        return None
-    try:
-        return int(value)
-    except ValueError:
-        pass
-    return _log_levels[value.lower()]
-
-
 class LoggerheadConfig(object):
     """A configuration object."""
 
@@ -128,10 +99,6 @@
         else:
             return cmd_config
 
-    def get_log_level(self):
-        opt = self.get_option('log_level')
-        return _level_to_int_level(opt)
-
     def get_arg(self, index):
         """Get an arg from the arg list."""
         return self._args[index]

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2011-03-16 11:40:05 +0000
+++ loggerhead/controllers/__init__.py	2011-02-10 17:01:10 +0000
@@ -94,7 +94,7 @@
 
         vals.update(self.get_values(path, kwargs, headers))
 
-        self.log.info('Getting information for %s: %.3f secs' % (
+        self.log.info('Getting information for %s: %r secs' % (
             self.__class__.__name__, time.time() - z))
         if 'Content-Type' not in headers:
             headers['Content-Type'] = 'text/html'
@@ -108,7 +108,7 @@
         template.expand_into(w, **vals)
         w.flush()
         self.log.info(
-            'Rendering %s: %.3f secs, %s bytes' % (
+            'Rendering %s: %r secs, %s bytes' % (
                 self.__class__.__name__, time.time() - z, w.bytes))
         return []
 

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2011-03-12 13:25:52 +0000
+++ loggerhead/controllers/changelog_ui.py	2011-03-02 14:07:21 +0000
@@ -47,8 +47,7 @@
 
         try:
             revid, start_revid, revid_list = history.get_view(
-                revid, start_revid, filter_file_id, query,
-                extra_rev_count=pagesize+1)
+                revid, start_revid, filter_file_id, query)
             util.set_context(kwargs)
 
             if (query is not None) and (len(revid_list) == 0):

=== modified file 'loggerhead/controllers/diff_ui.py'
--- loggerhead/controllers/diff_ui.py	2011-03-18 09:39:01 +0000
+++ loggerhead/controllers/diff_ui.py	2010-04-08 01:08:33 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008-2011 Canonical Ltd.
+# Copyright (C) 2008  Canonical Ltd.
 #                     (Authored by Martin Albisetti <argentina@gmail.com>)
 #
 # This program is free software; you can redistribute it and/or modify
@@ -26,6 +26,8 @@
 
 from loggerhead.controllers import TemplatedBranchView
 
+log = logging.getLogger("loggerhead.controllers")
+
 
 class DiffUI(TemplatedBranchView):
     """Class to output a diff for a single file or revisions."""

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2010-07-12 15:12:04 +0000
+++ loggerhead/controllers/inventory_ui.py	2009-03-19 00:44:05 +0000
@@ -22,7 +22,7 @@
 import posixpath
 import urllib
 
-from paste.httpexceptions import HTTPNotFound, HTTPMovedPermanently
+from paste.httpexceptions import HTTPNotFound
 
 from bzrlib import errors
 from bzrlib.revision import is_null as is_null_rev
@@ -31,6 +31,8 @@
 from loggerhead.controllers import TemplatedBranchView
 
 
+log = logging.getLogger("loggerhead.controllers")
+
 
 def dirname(path):
     if path is not None:
@@ -43,7 +45,7 @@
 
     template_path = 'loggerhead.templates.inventory'
 
-    def get_filelist(self, inv, path, sort_type, revno_url):
+    def get_filelist(self, inv, path, sort_type):
         """
         return the list of all files (and their attributes) within a given
         path subtree.
@@ -56,9 +58,6 @@
         dir_ie = inv[file_id]
         file_list = []
 
-        if dir_ie.kind != 'directory':
-            raise HTTPMovedPermanently(self._branch.context_url(['/view', revno_url, path]))
-
         revid_set = set()
 
         for filename, entry in dir_ie.children.iteritems():
@@ -151,7 +150,7 @@
 
             # Create breadcrumb trail for the path within the branch
             branch_breadcrumbs = util.branch_breadcrumbs(path, rev_tree, 'files')
-            filelist = self.get_filelist(rev_tree.inventory, path, sort_type, revno_url)
+            filelist = self.get_filelist(rev_tree.inventory, path, sort_type)
         else:
             start_revid = None
             change = None

=== modified file 'loggerhead/controllers/view_ui.py'
--- loggerhead/controllers/view_ui.py	2011-03-23 02:37:07 +0000
+++ loggerhead/controllers/view_ui.py	2010-12-01 08:30:02 +0000
@@ -17,6 +17,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import cgi
 import os
 import time
 
@@ -24,7 +25,7 @@
 import bzrlib.textfile
 import bzrlib.osutils
 
-from paste.httpexceptions import HTTPBadRequest, HTTPServerError, HTTPMovedPermanently
+from paste.httpexceptions import HTTPBadRequest, HTTPServerError
 
 from loggerhead.controllers import TemplatedBranchView
 try:
@@ -64,7 +65,7 @@
             extra_lines = len(file_lines) - len(hl_lines)
             hl_lines.extend([u''] * extra_lines)
         else:
-            hl_lines = map(util.html_escape, file_lines)
+            hl_lines = map(cgi.escape, file_lines)
         
         return hl_lines;
 
@@ -119,9 +120,6 @@
             raise HTTPServerError('Could not fetch changes')
         branch_breadcrumbs = util.branch_breadcrumbs(path, inv, 'files')
 
-        if inv[file_id].kind == "directory":
-            raise HTTPMovedPermanently(self._branch.context_url(['/files', revno_url, path]))
-
         return {
             # In AnnotateUI, "annotated" is a generator giving revision
             # numbers per lines, but the template checks if "annotated" is

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2011-03-25 11:38:43 +0000
+++ loggerhead/history.py	2010-05-10 13:48:25 +0000
@@ -1,4 +1,5 @@
-# Copyright (C) 2006-2011 Canonical Ltd.
+#
+# Copyright (C) 2008, 2009 Canonical Ltd.
 #                     (Authored by Martin Albisetti <argentina@gmail.com>)
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
 # Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
@@ -34,7 +35,6 @@
 import textwrap
 import threading
 
-from bzrlib import tag
 import bzrlib.branch
 import bzrlib.delta
 import bzrlib.errors
@@ -327,16 +327,7 @@
         revid in revid_list.
         """
         if revid_list is None:
-            # Just yield the mainline, starting at start_revid
-            revid = start_revid
-            is_null = bzrlib.revision.is_null
-            while not is_null(revid):
-                yield revid
-                parents = self._rev_info[self._rev_indices[revid]][2]
-                if not parents:
-                    return
-                revid = parents[0]
-            return
+            revid_list = [r[0][1] for r in self._rev_info]
         revid_set = set(revid_list)
         revid = start_revid
 
@@ -349,14 +340,10 @@
                 r.add(self._rev_info[i][0][1])
                 i += 1
             return r
-        while revid_set:
+        while True:
             if bzrlib.revision.is_null(revid):
                 return
-            rev_introduced = introduced_revisions(revid)
-            matching = rev_introduced.intersection(revid_set)
-            if matching:
-                # We don't need to look for these anymore.
-                revid_set.difference_update(matching)
+            if introduced_revisions(revid) & revid_set:
                 yield revid
             parents = self._rev_info[self._rev_indices[revid]][2]
             if len(parents) == 0:
@@ -477,41 +464,15 @@
         if revid is None:
             revid = self.last_revid
         if file_id is not None:
-            revlist = list(
-                self.get_short_revision_history_by_fileid(file_id))
-            revlist = self.get_revids_from(revlist, revid)
+            # since revid is 'start_revid', possibly should start the path
+            # tracing from revid... FIXME
+            revlist = list(self.get_short_revision_history_by_fileid(file_id))
+            revlist = list(self.get_revids_from(revlist, revid))
         else:
-            revlist = self.get_revids_from(None, revid)
+            revlist = list(self.get_revids_from(None, revid))
         return revlist
 
-    @staticmethod
-    def _iterate_sufficiently(iterable, stop_at, extra_rev_count):
-        """Return a list of iterable.
-
-        If extra_rev_count is None, fully consume iterable.
-        Otherwise, stop at 'stop_at' + extra_rev_count.
-
-        Example:
-          iterate until you find stop_at, then iterate 10 more times.
-        """
-        if extra_rev_count is None:
-            return list(iterable)
-        result = []
-        found = False
-        for n in iterable:
-            result.append(n)
-            if n == stop_at:
-                found = True
-                break
-        if found:
-            for count, n in enumerate(iterable):
-                if count >= extra_rev_count:
-                    break
-                result.append(n)
-        return result
-
-    def get_view(self, revid, start_revid, file_id, query=None,
-                 extra_rev_count=None):
+    def get_view(self, revid, start_revid, file_id, query=None):
         """
         use the URL parameters (revid, start_revid, file_id, and query) to
         determine the revision list we're viewing (start_revid, file_id, query)
@@ -522,10 +483,6 @@
               file.
             - if a start_revid is given, we're viewing the branch from a
               specific revision up the tree.
-            - if extra_rev_count is given, find the view from start_revid =>
-              revid, and continue an additional 'extra_rev_count'. If not
-              given, then revid_list will contain the full history of
-              start_revid
 
         these may be combined to view revisions for a specific file, from
         a specific revision, with a specific search query.
@@ -544,16 +501,12 @@
 
         if query is None:
             revid_list = self.get_file_view(start_revid, file_id)
-            revid_list = self._iterate_sufficiently(revid_list, revid,
-                                                    extra_rev_count)
             if revid is None:
                 revid = start_revid
             if revid not in revid_list:
                 # if the given revid is not in the revlist, use a revlist that
                 # starts at the given revid.
                 revid_list = self.get_file_view(revid, file_id)
-                revid_list = self._iterate_sufficiently(revid_list, revid,
-                                                        extra_rev_count)
                 start_revid = revid
             return revid, start_revid, revid_list
 
@@ -717,17 +670,12 @@
 
         revtags = None
         if revision.revision_id in self._branch_tags:
-          # tag.sort_* functions expect (tag, data) pairs, so we generate them,
-          # and then strip them
-          tags = [(t, None) for t in self._branch_tags[revision.revision_id]]
-          tag.sort_natural(self._branch, tags)
-          revtags = u', '.join([t[0] for t in tags])
+          revtags = ', '.join(self._branch_tags[revision.revision_id])
 
         entry = {
             'revid': revision.revision_id,
             'date': datetime.datetime.fromtimestamp(revision.timestamp),
             'utc_date': datetime.datetime.utcfromtimestamp(revision.timestamp),
-            'committer': revision.committer,
             'authors': revision.get_apparent_authors(),
             'branch_nick': revision.properties.get('branch-nick', None),
             'short_comment': short_message,
@@ -738,8 +686,7 @@
             'tags': revtags,
         }
         if isinstance(revision, bzrlib.foreign.ForeignRevision):
-            foreign_revid, mapping = (
-                revision.foreign_revid, revision.mapping)
+            foreign_revid, mapping = (rev.foreign_revid, rev.mapping)
         elif ":" in revision.revision_id:
             try:
                 foreign_revid, mapping = \

=== modified file 'loggerhead/main.py'
--- loggerhead/main.py	2011-03-16 11:39:27 +0000
+++ loggerhead/main.py	2009-11-27 18:30:24 +0000
@@ -56,39 +56,21 @@
     return config, base
 
 
-def setup_logging(config, init_logging=True, log_file=None):
-    log_level = config.get_log_level()
-    if init_logging:
-        logging.basicConfig()
-        if log_level is not None:
-            logging.getLogger('').setLevel(log_level)
+def setup_logging(config):
+    logging.basicConfig()
+    logging.getLogger('').setLevel(logging.DEBUG)
     logger = logging.getLogger('loggerhead')
-    if log_level is not None:
-        logger.setLevel(log_level)
-    if log_file is not None:
-        handler = logging.StreamHandler(log_file)
+    if config.get_option('log_folder'):
+        logfile_path = os.path.join(
+            config.get_option('log_folder'), 'serve-branches.log')
     else:
-        if config.get_option('log_folder'):
-            logfile_path = os.path.join(
-                config.get_option('log_folder'), 'serve-branches.log')
-        else:
-            logfile_path = 'serve-branches.log'
-        handler = logging.FileHandler(logfile_path, 'a')
-        formatter = logging.Formatter('%(asctime)s %(levelname)-8s %(name)s:'
-                                      ' %(message)s')
-        handler.setFormatter(formatter)
-    # We set the handler to accept all messages, the *logger* won't emit them
-    # if it is configured to suppress it
-    handler.setLevel(logging.DEBUG)
-    logger.addHandler(handler)
-    def _restrict_logging(logger_name):
-        logger = logging.getLogger(logger_name)
-        if logger.getEffectiveLevel() < logging.INFO:
-            logger.setLevel(logging.INFO)
-    # simpleTAL is *very* verbose in DEBUG mode, which is otherwise the
-    # default. So quiet it up a bit.
-    _restrict_logging('simpleTAL')
-    _restrict_logging('simpleTALES')
+        logfile_path = 'serve-branches.log'
+    logfile = logging.FileHandler(logfile_path, 'a')
+    formatter = logging.Formatter('%(asctime)s %(levelname)-8s %(name)s:'
+                                  ' %(message)s')
+    logfile.setFormatter(formatter)
+    logfile.setLevel(logging.DEBUG)
+    logger.addHandler(logfile)
     return logger
 
 

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2011-03-23 04:04:44 +0000
+++ loggerhead/templatefunctions.py	2011-03-02 14:07:21 +0000
@@ -14,8 +14,8 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import cgi
 import os
-import urllib
 
 import pkg_resources
 
@@ -23,7 +23,6 @@
 
 import loggerhead
 from loggerhead.zptsupport import zpt
-from loggerhead.util import html_format
 
 
 templatefunctions = {}
@@ -50,21 +49,16 @@
     if style == 'fragment':
         def file_link(filename):
             if currently_showing and filename == currently_showing:
-                return html_format(
-                    '<b><a href="#%s">%s</a></b>',
-                    urllib.quote(filename.encode('utf-8')), filename)
+                return '<b><a href="#%s">%s</a></b>' % (
+                    cgi.escape(filename), cgi.escape(filename))
             else:
                 return revision_link(
-                    url, entry.revno, filename,
-                    '#' + urllib.quote(filename.encode('utf-8')))
+                    url, entry.revno, filename, '#' + filename)
     else:
         def file_link(filename):
-            return html_format(
-                '<a href="%s%s" title="View changes to %s in revision %s">'
-                '%s</a>',
-                url(['/revision', entry.revno]),
-                '#' + urllib.quote(filename.encode('utf-8')),
-                filename, entry.revno, filename)
+            return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
+                url(['/revision', entry.revno]), '#' + filename, cgi.escape(filename),
+                cgi.escape(entry.revno), cgi.escape(filename))
     return _pt('revisionfilechanges').expand(
         entry=entry, file_changes=file_changes, file_link=file_link, **templatefunctions)
 
@@ -128,16 +122,14 @@
 
 @templatefunc
 def view_link(url, revno, path):
-    return html_format(
-        '<a href="%s" title="Annotate %s">%s</a>',
-        url(['/view', revno, path]), path, path)
-
+    return '<a href="%s" title="Annotate %s">%s</a>' % (
+        url(['/view', revno, path]), cgi.escape(path), cgi.escape(path))
 
 @templatefunc
 def revision_link(url, revno, path, frag=''):
-    return html_format(
-        '<a href="%s%s" title="View changes to %s in revision %s">%s</a>',
-        url(['/revision', revno, path]), frag, path, revno, path)
+    return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
+        url(['/revision', revno, path]), frag, cgi.escape(path),
+        cgi.escape(revno), cgi.escape(path))
 
 
 @templatefunc

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2011-03-16 12:37:17 +0000
+++ loggerhead/templates/revisioninfo.pt	2011-02-18 05:41:17 +0000
@@ -3,10 +3,6 @@
         <ul>
             <li class="committer">
                 <strong>Committer:</strong>
-                <span tal:content="python:util.hide_email(change.committer)"></span>
-            </li>
-            <li class="authors" tal:condition="python:len(change.authors) > 1 or change.authors[0] != change.committer">
-                <strong>Author(s):</strong>
                 <span tal:content="python:', '.join(util.hide_emails(change.authors))"></span>
             </li>
             <li class="timer">

=== modified file 'loggerhead/tests/__init__.py'
--- loggerhead/tests/__init__.py	2011-03-23 03:59:38 +0000
+++ loggerhead/tests/__init__.py	2011-02-10 23:06:59 +0000
@@ -20,12 +20,8 @@
         (__name__ + '.' + x) for x in [
             'test_controllers',
             'test_corners',
-            'test_history',
-            'test_http_head',
             'test_load_test',
             'test_simple',
-            'test_revision_ui',
             'test_templating',
-            'test_util',
         ]]))
     return standard_tests

=== modified file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2011-03-15 02:56:59 +0000
+++ loggerhead/tests/test_controllers.py	2011-02-10 17:01:10 +0000
@@ -47,7 +47,7 @@
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
             ['filename'])
         inv = bzrbranch.repository.get_inventory(bzrbranch.last_revision())
-        self.assertEqual(1, len(inv_ui.get_filelist(inv, '', 'filename', 'head')))
+        self.assertEqual(1, len(inv_ui.get_filelist(inv, '', 'filename')))
 
     def test_smoke(self):
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(

=== removed file 'loggerhead/tests/test_history.py'
--- loggerhead/tests/test_history.py	2011-03-25 11:38:43 +0000
+++ loggerhead/tests/test_history.py	1970-01-01 00:00:00 +0000
@@ -1,325 +0,0 @@
-# Copyright (C) 2011 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""Direct tests of the loggerhead/history.py module"""
-
-from bzrlib.foreign import (
-    ForeignRevision,
-    ForeignVcs,
-    VcsMapping,
-    )
-
-from datetime import datetime
-from bzrlib import tests
-
-from loggerhead import history as _mod_history
-
-
-class TestCaseWithExamples(tests.TestCaseWithMemoryTransport):
-
-    def make_linear_ancestry(self):
-        # Time goes up
-        # rev-3
-        #  |
-        # rev-2
-        #  |
-        # rev-1
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('rev-1', None, [
-            ('add', ('', 'root-id', 'directory', None))])
-        builder.build_snapshot('rev-2', ['rev-1'], [])
-        builder.build_snapshot('rev-3', ['rev-2'], [])
-        builder.finish_series()
-        b = builder.get_branch()
-        self.addCleanup(b.lock_read().unlock)
-        return _mod_history.History(b, {})
-
-    def make_long_linear_ancestry(self):
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('A', None, [
-            ('add', ('', 'root-id', 'directory', None))])
-        for r in "BCDEFGHIJKLMNOPQRSTUVWXYZ":
-            builder.build_snapshot(r, None, [])
-        builder.finish_series()
-        b = builder.get_branch()
-        self.addCleanup(b.lock_read().unlock)
-        return _mod_history.History(b, {})
-
-    def make_merged_ancestry(self):
-        # Time goes up
-        # rev-3
-        #  |  \
-        #  |  rev-2
-        #  |  /
-        # rev-1
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('rev-1', None, [
-            ('add', ('', 'root-id', 'directory', None))])
-        builder.build_snapshot('rev-2', ['rev-1'], [])
-        builder.build_snapshot('rev-3', ['rev-1', 'rev-2'], [])
-        builder.finish_series()
-        b = builder.get_branch()
-        self.addCleanup(b.lock_read().unlock)
-        return _mod_history.History(b, {})
-
-    def make_deep_merged_ancestry(self):
-        # Time goes up
-        # F
-        # |\
-        # | E
-        # | |\
-        # | | D
-        # | |/
-        # B C
-        # |/
-        # A
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('A', None, [
-            ('add', ('', 'root-id', 'directory', None))])
-        builder.build_snapshot('B', ['A'], [])
-        builder.build_snapshot('C', ['A'], [])
-        builder.build_snapshot('D', ['C'], [])
-        builder.build_snapshot('E', ['C', 'D'], [])
-        builder.build_snapshot('F', ['B', 'E'], [])
-        builder.finish_series()
-        b = builder.get_branch()
-        self.addCleanup(b.lock_read().unlock)
-        return _mod_history.History(b, {})
-
-    def assertRevidsFrom(self, expected, history, search_revs, tip_rev):
-        self.assertEqual(expected,
-                         list(history.get_revids_from(search_revs, tip_rev)))
-
-
-class _DictProxy(object):
-
-    def __init__(self, d):
-        self._d = d
-        self._accessed = set()
-        self.__setitem__ = d.__setitem__
-
-    def __getitem__(self, name):
-        self._accessed.add(name)
-        return self._d[name]
-
-    def __len__(self):
-        return len(self._d)
-
-
-def track_rev_info_accesses(h):
-    """Track __getitem__ access to History._rev_info,
-
-    :return: set of items accessed
-    """
-    h._rev_info = _DictProxy(h._rev_info)
-    return h._rev_info._accessed
-
-
-class TestHistoryGetRevidsFrom(TestCaseWithExamples):
-
-    def test_get_revids_from_simple_mainline(self):
-        history = self.make_linear_ancestry()
-        self.assertRevidsFrom(['rev-3', 'rev-2', 'rev-1'],
-                              history, None, 'rev-3')
-
-    def test_get_revids_from_merged_mainline(self):
-        history = self.make_merged_ancestry()
-        self.assertRevidsFrom(['rev-3', 'rev-1'],
-                              history, None, 'rev-3')
-
-    def test_get_revids_given_one_rev(self):
-        history = self.make_merged_ancestry()
-        # rev-3 was the first mainline revision to see rev-2.
-        self.assertRevidsFrom(['rev-3'], history, ['rev-2'], 'rev-3')
-
-    def test_get_revids_deep_ancestry(self):
-        history = self.make_deep_merged_ancestry()
-        self.assertRevidsFrom(['F'], history, ['F'], 'F')
-        self.assertRevidsFrom(['F'], history, ['E'], 'F')
-        self.assertRevidsFrom(['F'], history, ['D'], 'F')
-        self.assertRevidsFrom(['F'], history, ['C'], 'F')
-        self.assertRevidsFrom(['B'], history, ['B'], 'F')
-        self.assertRevidsFrom(['A'], history, ['A'], 'F')
-
-    def test_get_revids_doesnt_over_produce_simple_mainline(self):
-        # get_revids_from shouldn't walk the whole ancestry just to get the
-        # answers for the first few revisions.
-        history = self.make_long_linear_ancestry()
-        accessed = track_rev_info_accesses(history)
-        result = history.get_revids_from(None, 'Z')
-        self.assertEqual(set(), accessed)
-        self.assertEqual('Z', result.next())
-        # We already know 'Z' because we passed it in.
-        self.assertEqual(set(), accessed)
-        self.assertEqual('Y', result.next())
-        self.assertEqual(set([history._rev_indices['Z']]), accessed)
-
-    def test_get_revids_doesnt_over_produce_for_merges(self):
-        # get_revids_from shouldn't walk the whole ancestry just to get the
-        # answers for the first few revisions.
-        history = self.make_long_linear_ancestry()
-        accessed = track_rev_info_accesses(history)
-        result = history.get_revids_from(['X', 'V'], 'Z')
-        self.assertEqual(set(), accessed)
-        self.assertEqual('X', result.next())
-        # We access 'W' because we are checking that W wasn't merged into X.
-        # The important bit is that we aren't getting the whole ancestry.
-        self.assertEqual(set([history._rev_indices[x] for x in 'ZYXW']),
-                         accessed)
-        self.assertEqual('V', result.next())
-        self.assertEqual(set([history._rev_indices[x] for x in 'ZYXWVU']),
-                         accessed)
-        self.assertRaises(StopIteration, result.next)
-        self.assertEqual(set([history._rev_indices[x] for x in 'ZYXWVU']),
-                         accessed)
-
-
-
-class TestHistoryChangeFromRevision(tests.TestCaseWithTransport):
-
-    def make_single_commit(self):
-        tree = self.make_branch_and_tree('test')
-        rev_id = tree.commit('Commit Message', timestamp=1299838474.317,
-            timezone=3600, committer='Joe Example <joe@example.com>',
-            revprops={})
-        self.addCleanup(tree.branch.lock_write().unlock)
-        rev = tree.branch.repository.get_revision(rev_id)
-        history = _mod_history.History(tree.branch, {})
-        return history, rev
-
-    def test_simple(self):
-        history, rev = self.make_single_commit()
-        change = history._change_from_revision(rev)
-        self.assertEqual(rev.revision_id, change.revid)
-        self.assertEqual(datetime.fromtimestamp(1299838474.317),
-                         change.date)
-        self.assertEqual(datetime.utcfromtimestamp(1299838474.317),
-                         change.utc_date)
-        self.assertEqual(['Joe Example <joe@example.com>'],
-                         change.authors)
-        self.assertEqual('test', change.branch_nick)
-        self.assertEqual('Commit Message', change.short_comment)
-        self.assertEqual('Commit Message', change.comment)
-        self.assertEqual(['Commit&nbsp;Message'], change.comment_clean)
-        self.assertEqual([], change.parents)
-        self.assertEqual([], change.bugs)
-        self.assertEqual(None, change.tags)
-
-    def test_tags(self):
-        history, rev = self.make_single_commit()
-        b = history._branch
-        b.tags.set_tag('tag-1', rev.revision_id)
-        b.tags.set_tag('tag-2', rev.revision_id)
-        b.tags.set_tag('Tag-10', rev.revision_id)
-        change = history._change_from_revision(rev)
-        # tags are 'naturally' sorted, sorting numbers in order, and ignoring
-        # case, etc.
-        self.assertEqual('tag-1, tag-2, Tag-10', change.tags)
-
-    def test_committer_vs_authors(self):
-        tree = self.make_branch_and_tree('test')
-        rev_id = tree.commit('Commit Message', timestamp=1299838474.317,
-            timezone=3600, committer='Joe Example <joe@example.com>',
-            revprops={'authors': u'A Author <aauthor@example.com>\n'
-                                 u'B Author <bauthor@example.com>'})
-        self.addCleanup(tree.branch.lock_write().unlock)
-        rev = tree.branch.repository.get_revision(rev_id)
-        history = _mod_history.History(tree.branch, {})
-        change = history._change_from_revision(rev)
-        self.assertEqual(u'Joe Example <joe@example.com>',
-                         change.committer)
-        self.assertEqual([u'A Author <aauthor@example.com>',
-                          u'B Author <bauthor@example.com>'],
-                         change.authors)
-
-
-class TestHistory_IterateSufficiently(tests.TestCase):
-
-    def assertIterate(self, expected, iterable, stop_at, extra_rev_count):
-        self.assertEqual(expected, _mod_history.History._iterate_sufficiently(
-            iterable, stop_at, extra_rev_count))
-
-    def test_iter_no_extra(self):
-        lst = list('abcdefghijklmnopqrstuvwxyz')
-        self.assertIterate(['a', 'b', 'c'], iter(lst), 'c', 0)
-        self.assertIterate(['a', 'b', 'c', 'd'], iter(lst), 'd', 0)
-
-    def test_iter_not_found(self):
-        # If the key in question isn't found, we just exhaust the list
-        lst = list('abcdefghijklmnopqrstuvwxyz')
-        self.assertIterate(lst, iter(lst), 'not-there', 0)
-
-    def test_iter_with_extra(self):
-        lst = list('abcdefghijklmnopqrstuvwxyz')
-        self.assertIterate(['a', 'b', 'c'], iter(lst), 'b', 1)
-        self.assertIterate(['a', 'b', 'c', 'd', 'e'], iter(lst), 'c', 2)
-
-    def test_iter_with_too_many_extra(self):
-        lst = list('abcdefghijklmnopqrstuvwxyz')
-        self.assertIterate(lst, iter(lst), 'y', 10)
-        self.assertIterate(lst, iter(lst), 'z', 10)
-
-    def test_iter_with_extra_None(self):
-        lst = list('abcdefghijklmnopqrstuvwxyz')
-        self.assertIterate(lst, iter(lst), 'z', None)
-
-
-
-class TestHistoryGetView(TestCaseWithExamples):
-
-    def test_get_view_limited_history(self):
-        # get_view should only load enough history to serve the result, not all
-        # history.
-        history = self.make_long_linear_ancestry()
-        accessed = track_rev_info_accesses(history)
-        revid, start_revid, revid_list = history.get_view('Z', 'Z', None,
-                                                      extra_rev_count=5)
-        self.assertEqual(['Z', 'Y', 'X', 'W', 'V', 'U'], revid_list)
-        self.assertEqual('Z', revid)
-        self.assertEqual('Z', start_revid)
-        self.assertEqual(set([history._rev_indices[x] for x in 'ZYXWVU']),
-                         accessed)
-
-
-class TestHistoryGetChangedUncached(TestCaseWithExamples):
-
-    def test_native(self):
-        history = self.make_linear_ancestry()
-        changes = history.get_changes_uncached(['rev-1', 'rev-2'])
-        self.assertEquals(2, len(changes))
-        self.assertEquals('rev-1', changes[0].revid)
-        self.assertEquals('rev-2', changes[1].revid)
-        self.assertIs(None, getattr(changes[0], 'foreign_vcs', None))
-        self.assertIs(None, getattr(changes[0], 'foreign_revid', None))
-
-    def test_foreign(self):
-        # Test with a mocked foreign revision, as it's not possible
-        # to rely on any foreign plugins being installed.
-        history = self.make_linear_ancestry()
-        foreign_vcs = ForeignVcs(None, "vcs")
-        foreign_vcs.show_foreign_revid = repr
-        foreign_rev = ForeignRevision(("uuid", 1234), VcsMapping(foreign_vcs),
-            "revid-in-bzr", message="message",
-            timestamp=234423423.3)
-        change = history._change_from_revision(foreign_rev)
-        self.assertEquals('revid-in-bzr', change.revid)
-        self.assertEquals("('uuid', 1234)", change.foreign_revid)
-        self.assertEquals("vcs", change.foreign_vcs)

=== removed file 'loggerhead/tests/test_http_head.py'
--- loggerhead/tests/test_http_head.py	2011-02-10 02:33:15 +0000
+++ loggerhead/tests/test_http_head.py	1970-01-01 00:00:00 +0000
@@ -1,92 +0,0 @@
-# Copyright 2011 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for the HeadMiddleware app."""
-
-from cStringIO import StringIO
-
-from bzrlib import tests
-
-from loggerhead.apps import http_head
-
-
-content = ["<html>",
-           "<head><title>Listed</title></head>",
-           "<body>Content</body>",
-           "</html>",
-          ]
-headers = {'X-Ignored-Header': 'Value'}
-
-def yielding_app(environ, start_response):
-    writer = start_response('200 OK', headers)
-    for chunk in content:
-        yield chunk
-
-
-def list_app(environ, start_response):
-    writer = start_response('200 OK', headers)
-    return content
-
-
-def writer_app(environ, start_response):
-    writer = start_response('200 OK', headers)
-    for chunk in content:
-        writer(chunk)
-    return []
-
-
-class TestHeadMiddleware(tests.TestCase):
-
-    def _trap_start_response(self, status, response_headers, exc_info=None):
-        self._write_buffer = StringIO()
-        self._start_response_passed = (status, response_headers, exc_info)
-        return self._write_buffer.write
-
-    def _consume_app(self, app, request_method):
-        environ = {'REQUEST_METHOD': request_method}
-        value = list(app(environ, self._trap_start_response))
-        self._write_buffer.writelines(value)
-
-    def _verify_get_passthrough(self, app):
-        app = http_head.HeadMiddleware(app)
-        self._consume_app(app, 'GET')
-        self.assertEqual(('200 OK', headers, None), self._start_response_passed)
-        self.assertEqualDiff(''.join(content), self._write_buffer.getvalue())
-
-    def _verify_head_no_body(self, app):
-        app = http_head.HeadMiddleware(app)
-        self._consume_app(app, 'HEAD')
-        self.assertEqual(('200 OK', headers, None), self._start_response_passed)
-        self.assertEqualDiff('', self._write_buffer.getvalue())
-
-    def test_get_passthrough_yielding(self):
-        self._verify_get_passthrough(yielding_app)
-
-    def test_head_passthrough_yielding(self):
-        self._verify_head_no_body(yielding_app)
-
-    def test_get_passthrough_list(self):
-        self._verify_get_passthrough(list_app)
-
-    def test_head_passthrough_list(self):
-        self._verify_head_no_body(list_app)
-
-    def test_get_passthrough_writer(self):
-        self._verify_get_passthrough(writer_app)
-
-    def test_head_passthrough_writer(self):
-        self._verify_head_no_body(writer_app)
-

=== removed file 'loggerhead/tests/test_revision_ui.py'
--- loggerhead/tests/test_revision_ui.py	2011-03-16 12:37:17 +0000
+++ loggerhead/tests/test_revision_ui.py	1970-01-01 00:00:00 +0000
@@ -1,46 +0,0 @@
-# Copyright (C) 2011 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-
-from loggerhead.tests.test_simple import BasicTests
-
-
-class TestRevisionUI(BasicTests):
-
-    def test_authors_vs_committer(self):
-        self.createBranch()
-        self.tree.commit('First', committer="Joe Example <joe@example.com>",
-            revprops={'authors': u'A Author <aauthor@example.com>\n'
-                                 u'B Author <bauthor@example.com>'})
-        app = self.setUpLoggerhead()
-        res = app.get('/revision/1')
-        # We would like to assert that Joe Example is connected to Committer,
-        # and the Authors are connected. However, that requires asserting the
-        # exact HTML connections, which I wanted to avoid.
-        res.mustcontain('Committer', 'Joe Example',
-                        'Author(s)', 'A Author, B Author')
-
-    def test_author_is_committer(self):
-        self.createBranch()
-        self.tree.commit('First', committer="Joe Example <joe@example.com>")
-        app = self.setUpLoggerhead()
-        res = app.get('/revision/1')
-        # We would like to assert that Joe Example is connected to Committer,
-        # and the Authors are connected. However, that requires asserting the
-        # exact HTML connections, which I wanted to avoid.
-        res.mustcontain('Committer', 'Joe Example')
-        self.assertFalse('Author(s)' in res.body)

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2011-03-23 03:36:23 +0000
+++ loggerhead/tests/test_simple.py	2011-03-10 14:22:12 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008, 2009, 2011 Canonical Ltd.
+# Copyright (C) 2007-2011 Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,9 +27,8 @@
 from bzrlib import config
 
 from loggerhead.apps.branch import BranchWSGIApp
-from loggerhead.apps.http_head import HeadMiddleware
 from paste.fixture import TestApp
-from paste.httpexceptions import HTTPExceptionHandler, HTTPMovedPermanently
+from paste.httpexceptions import HTTPExceptionHandler
 
 
 
@@ -56,11 +55,9 @@
 
         self.filecontents = ('some\nmultiline\ndata\n'
                              'with<htmlspecialchars\n')
-        filenames = ['myfilename', 'anotherfile<']
         self.build_tree_contents(
-            (filename, self.filecontents) for filename in filenames)
-        for filename in filenames:
-            self.tree.add(filename, '%s-id' % filename)
+            [('myfilename', self.filecontents)])
+        self.tree.add('myfilename', 'myfile-id')
         self.fileid = self.tree.path2id('myfilename')
         self.msg = 'a very exciting commit message <'
         self.revid = self.tree.commit(message=self.msg)
@@ -72,7 +69,7 @@
 
     def test_changes_for_file(self):
         app = self.setUpLoggerhead()
-        res = app.get('/changes?filter_file_id=myfilename-id')
+        res = app.get('/changes?filter_file_id=myfile-id')
         res.mustcontain(cgi.escape(self.msg))
 
     def test_changes_branch_from(self):
@@ -133,8 +130,6 @@
     def test_revision(self):
         app = self.setUpLoggerhead()
         res = app.get('/revision/1')
-        res.mustcontain(no=['anotherfile<'])
-        res.mustcontain('anotherfile&lt;')
         res.mustcontain('myfilename')
 
 
@@ -175,59 +170,6 @@
         res = app.get('/changes', status=404)
 
 
-class TestControllerRedirects(BasicTests):
-    """
-    Test that a file under /files redirects to /view,
-    and a directory under /view redirects to /files.
-    """
-
-    def setUp(self):
-        BasicTests.setUp(self)
-        self.createBranch()
-        self.build_tree(('file', 'folder/', 'folder/file'))
-        self.tree.smart_add([])
-        self.tree.commit('')
-
-    def test_view_folder(self):
-        app = TestApp(BranchWSGIApp(self.tree.branch, '').app)
-
-        e = self.assertRaises(HTTPMovedPermanently, app.get, '/view/head:/folder')
-        self.assertEqual(e.location(), '/files/head:/folder')
-
-    def test_files_file(self):
-        app = TestApp(BranchWSGIApp(self.tree.branch, '').app)
-
-        e = self.assertRaises(HTTPMovedPermanently, app.get, '/files/head:/folder/file')
-        self.assertEqual(e.location(), '/view/head:/folder/file')
-        e = self.assertRaises(HTTPMovedPermanently, app.get, '/files/head:/file')
-        self.assertEqual(e.location(), '/view/head:/file')
-
-
-class TestHeadMiddleware(BasicTests):
-
-    def setUp(self):
-        BasicTests.setUp(self)
-        self.createBranch()
-        self.msg = 'trivial commit message'
-        self.revid = self.tree.commit(message=self.msg)
-
-    def setUpLoggerhead(self, **kw):
-        branch_app = BranchWSGIApp(self.tree.branch, '', **kw).app
-        return TestApp(HTTPExceptionHandler(HeadMiddleware(branch_app)))
-
-    def test_get(self):
-        app = self.setUpLoggerhead()
-        res = app.get('/changes')
-        res.mustcontain(self.msg)
-        self.assertEqual('text/html', res.header('Content-Type'))
-
-    def test_head(self):
-        app = self.setUpLoggerhead()
-        res = app.get('/changes', extra_environ={'REQUEST_METHOD': 'HEAD'})
-        self.assertEqual('text/html', res.header('Content-Type'))
-        self.assertEqualDiff('', res.body)
-
-
 #class TestGlobalConfig(BasicTests):
 #    """
 #    Test that global config settings are respected

=== removed file 'loggerhead/tests/test_util.py'
--- loggerhead/tests/test_util.py	2011-03-23 04:27:37 +0000
+++ loggerhead/tests/test_util.py	1970-01-01 00:00:00 +0000
@@ -1,33 +0,0 @@
-# Copyright 2011 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib import tests
-
-from loggerhead.util import html_escape, html_format
-
-
-class TestHTMLEscaping(tests.TestCase):
-
-    def test_html_escape(self):
-        self.assertEqual(
-            "foo &quot;&#39;&lt;&gt;&amp;",
-            html_escape("foo \"'<>&"))
-
-    def test_html_format(self):
-        self.assertEqual(
-            '<foo bar="baz&quot;&#39;">&lt;baz&gt;&amp;</foo>',
-            html_format(
-                '<foo bar="%s">%s</foo>', "baz\"'", "<baz>&"))

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2011-03-23 05:21:34 +0000
+++ loggerhead/util.py	2010-04-28 21:41:32 +0000
@@ -20,6 +20,7 @@
 #
 
 import base64
+import cgi
 import datetime
 import logging
 import re
@@ -213,47 +214,16 @@
 # only do this if unicode turns out to be a problem
 #_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
 
-# Can't be a dict; &amp; needs to be done first.
-html_entity_subs = [
-    ("&", "&amp;"),
-    ('"', "&quot;"),
-    ("'", "&#39;"), # &apos; is defined in XML, but not HTML.
-    (">", "&gt;"),
-    ("<", "&lt;"),
-    ]
-
-
-def html_escape(s):
-    """Transform dangerous (X)HTML characters into entities.
-
-    Like cgi.escape, except also escaping " and '. This makes it safe to use
-    in both attribute and element content.
-
-    If you want to safely fill a format string with escaped values, use
-    html_format instead
-    """
-    for char, repl in html_entity_subs:
-        s = s.replace(char, repl)
-    return s
-
-
-def html_format(template, *args):
-    """Safely format an HTML template string, escaping the arguments.
-
-    The template string must not be user-controlled; it will not be escaped.
-    """
-    return template % tuple(html_escape(arg) for arg in args)
-
-
 # FIXME: get rid of this method; use fixed_width() and avoid XML().
 
+
 def html_clean(s):
     """
     clean up a string for html display.  expand any tabs, encode any html
     entities, and replace spaces with '&nbsp;'.  this is primarily for use
     in displaying monospace text.
     """
-    s = html_escape(s.expandtabs())
+    s = cgi.escape(s.expandtabs())
     s = s.replace(' ', '&nbsp;')
     return s
 
@@ -299,7 +269,7 @@
         except UnicodeDecodeError:
             s = s.decode('iso-8859-15')
 
-    s = html_escape(s).expandtabs().replace(' ', NONBREAKING_SPACE)
+    s = cgi.escape(s).expandtabs().replace(' ', NONBREAKING_SPACE)
 
     return HSC.clean(s).replace('\n', '<br/>')
 

=== modified file 'loggerhead/wholehistory.py'
--- loggerhead/wholehistory.py	2010-04-26 19:37:26 +0000
+++ loggerhead/wholehistory.py	2009-10-21 14:40:23 +0000
@@ -80,6 +80,6 @@
             if revid not in c[1]:
                 c[1] = c[1] + (revid,)
 
-    log.info('built revision graph cache: %.3f secs' % (time.time() - z,))
+    log.info('built revision graph cache: %r secs' % (time.time() - z,))
 
     return (_rev_info, _rev_indices)

=== modified file 'loggerhead/zptsupport.py'
--- loggerhead/zptsupport.py	2010-05-12 15:01:44 +0000
+++ loggerhead/zptsupport.py	2009-03-02 05:44:20 +0000
@@ -23,6 +23,10 @@
 
 from simpletal import simpleTAL, simpleTALES
 
+logging.getLogger("simpleTAL").setLevel(logging.INFO)
+logging.getLogger("simpleTALES").setLevel(logging.INFO)
+
+
 _zpt_cache = {}
 
 

